//generated class! do not change
package name.panitz.crempel.tool.jugs;
import javax.swing.*;
import java.awt.Frame;
import java.awt.Container;
import java.awt.Component;
import java.awt.event.*;
import java.awt.*;
import java.util.Arrays;

 class FontSelectDialog extends JDialog{ 
  final JTextArea fontSizeArea = new  JTextArea(1,2);
  final JButton okButton = new JButton("OK");
  final JButton cancelButton = new JButton("Cancel");
  final JPanel buttonPanel = new JPanel();
  final JPanel sizePanel = new JPanel();
  final JLabel sizeLabel = new JLabel("size");

  final JRadioButton plain = new JRadioButton("plain");
  final JRadioButton bold = new JRadioButton("bold");
  final JRadioButton italic = new JRadioButton("italic");
  final ButtonGroup  styleButtonGroup = new ButtonGroup();
  final JPanel  styleButtonPanel  = new JPanel();
  JList fontList;

  int style  = Font.PLAIN;
  int size;
  final JugsGui jugsGui;

  private void createButtonGroup(){
    styleButtonGroup.add(plain);
    styleButtonGroup.add(bold);
    styleButtonGroup.add(italic);
    plain.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
          style=Font.PLAIN;
        }
      }
    );
    bold.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
        style=Font.BOLD;
        }
      }
    );

    italic.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e){ 
        style=Font.ITALIC;
        }
      }
    );

    styleButtonPanel.setLayout(new GridLayout(3,1));
    styleButtonPanel.add(plain);
    styleButtonPanel.add(bold);
    styleButtonPanel.add(italic);
  }

  FontSelectDialog(JugsGui frame,int size) {
    super(frame,"Font Size");
    this.jugsGui = frame; 
    this.size=size;

    createButtonGroup();

    fontList = new JList(
                      GraphicsEnvironment
                      .getLocalGraphicsEnvironment()
                      .getAvailableFontFamilyNames() 
		     );

    Container contentPane = getContentPane();

    JPanel p = new JPanel();
    p.setLayout(new BorderLayout());
    p.add(fontList,BorderLayout.WEST);
    p.add(styleButtonPanel,BorderLayout.CENTER);
    
    fontSizeArea.setText(""+size); 

    sizePanel.add(sizeLabel);
    sizePanel.add(fontSizeArea);
    p.add(sizePanel,BorderLayout.EAST);

    okButton.addActionListener(new OkListener(this));
    cancelButton.addActionListener(new CancelListener(this));

    buttonPanel.add(cancelButton);
    buttonPanel.add(okButton);
    p.add(buttonPanel,BorderLayout.SOUTH);
    contentPane.add(p);
    pack();
  }

  class OkListener implements ActionListener{
    Component c;
    OkListener(Component c){this.c = c;}

    public void actionPerformed(ActionEvent e) {
      size = new Integer(fontSizeArea.getText()).intValue();
      final java.awt.Font newFont
          = new Font((String)fontList.getSelectedValue()
                    ,style 
                    ,size);
      jugsGui.inputArea.setFont(newFont);
      jugsGui.outputArea.setFont(newFont);
      c.setVisible(false);
    }
  };

  class CancelListener implements ActionListener{
    Component c;
    CancelListener(Component c){this.c = c;}

    public void actionPerformed(ActionEvent e) {
      fontSizeArea.setText(""+size); 
      c.setVisible(false);
    }
  };

}

