//generated class! do not change
package name.panitz.crempel.tool.jugs;

import java.io.*;

import java.net.URLClassLoader;
import java.net.URL;
import java.lang.reflect.Method;

import java.util.List;
import java.util.ArrayList;
import java.util.ResourceBundle;

public class Jugs {

  static final public String MAIN_JUGS_CLASS="MainJugsTestClass";

  final public String USER_DIR
   = System.getProperty("user.dir")+"/";

  static ResourceBundle labels = ResourceBundle
  .getBundle("name.panitz.crempel.tool.jugs.JugsInfo");

  boolean expressionMode = true;

  public static void main(String [] args){
    Jugs jugs = new Jugs();
    System.out.println(labels.getString("WELCOME"));
    while (true){
      try {
        System.out.print(">\u0020");  
        String input
         =  new BufferedReader(
                  new InputStreamReader(System.in)).readLine();

        if (input.startsWith(":")) handleCommand(input,jugs);
        else jugs.execute(input);
      }catch (IOException e){
        System.out.println(e);
      }
    }
  }

  private static void handleCommand(String input,Jugs jugs){
    if (input.startsWith(":q")) System.exit(0);
    else if (input.startsWith(":s")) 
      jugs.expressionMode=false;
    else if (input.startsWith(":e")) 
      jugs.expressionMode=true;
    else if (input.startsWith(":h") || input.startsWith(":?")) 
      System.out.println(labels.getString("COMMAND_HELP"));
    else
     System.out.println(labels.getString("UNKNOWN_COMMAND")+input);
  }

  public void execute (String input){
    execute(input,new ArrayList<String>());
  }

  public void execute (String input,List<String> imports){
    try{
      final String newClass = mkClass(input,imports);
      final FileWriter writeClass
        = new FileWriter(USER_DIR+MAIN_JUGS_CLASS+".java");
      writeClass.write(newClass,0,newClass.length());
      writeClass.flush();

      String [] javacArg 
        = {"-source","1.5" 
          ,USER_DIR+MAIN_JUGS_CLASS+".java"};

      final int erg = com.sun.tools.javac.Main.compile(javacArg);

      if (erg==0){
        String classPath = System.getProperty("java.class.path");

        URL [] urls = { new URL("file://localhost/"+USER_DIR+"/")};

        JugsClassLoader loader = new JugsClassLoader(urls);

        java.util.StringTokenizer st
          = new java.util.StringTokenizer
              (classPath
              ,System.getProperty("path.separator"));

        while (st.hasMoreTokens()) {
          try {
            loader.addURL(new URL("file://localhost"+st.nextToken()));
          }catch (java.net.MalformedURLException _){}
        }

        Object o = loader.loadClass("MainJugsTestClass").newInstance();
        Class cl = o.getClass();

        final Class [] emptyC = {};
        Method m = cl.getMethod("run",emptyC);
        final Object [] empty = {};
        m.invoke(o,empty);
      }

    }catch (java.lang.reflect.InvocationTargetException e){
      System.out.println(e);
    }catch (NoSuchMethodException e){
      System.out.println(e);
    }catch (ClassNotFoundException e){
      System.out.println(e);
    }catch (InstantiationException e){
      System.out.println(e);
    }catch (IllegalAccessException e){
      System.out.println(e);
    }catch (IOException e){
      System.out.println(e);
    }catch (ClassFormatError e){
      System.out.println(e);
    }
  }

   public String mkClass(String content,List<String> imports){
     String importsString = "";
     for (String imp:imports)
       importsString = importsString+"import "+imp+";\n";

     if (expressionMode)
      return importsString
      +"public class "
      + MAIN_JUGS_CLASS
      +" implements name.panitz.crempel.tool.jugs"
      +".MainJugsTestClassPrototype {\n"
      +"  public void run() {\n"
      +"    try{System.out.println("+content+");}\n"
      +"    catch(Exception e){System.out.println(e);}}}";

     else return importsString
          +"public class "
          + MAIN_JUGS_CLASS
          +" implements name.panitz.crempel.tool.jugs."
                                 +"MainJugsTestClassPrototype {\n"
          +"  public void run(){try{"+content+"}\n"
          +"    catch(Exception e){System.out.println(e);}}}";
  }

  static public final String VERSION = "0.3.1";
}

