//generated class! do not change
package name.panitz.crempel.tool.jugs;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ImportsDialog 
  extends JDialog 
  implements ListSelectionListener{
  
  DefaultListModel listModel = new DefaultListModel();;
  private JList list=new JList(listModel);

  final JButton okButton = new JButton("OK");
  final JButton addButton = new JButton("Add");
  final JButton deleteButton = new JButton("Delete");
  private JTextField importName = new JTextField(30);

  ImportsDialog(Frame frame) {
    super(frame, "Imports", true);

    list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    list.addListSelectionListener(this);

    JScrollPane listScrollPane = new JScrollPane(list);
    importName.addActionListener(new AddListener());

    okButton.addActionListener(new OkListener(this)); 

    addButton.addActionListener(new AddListener());

    deleteButton.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        int index = list.getSelectedIndex();
        listModel.remove(index);

    int size = listModel.getSize();

    //Nobody's left, disable firing
    if (size == 0) {
          deleteButton.setEnabled(false);

        //Adjust the selection
        } else {
          //removed item in last position
          if (index == listModel.getSize())
            index--;
          //otherwise select same index
          list.setSelectedIndex(index); 
        }
      }
    });

    JPanel buttonPane = new JPanel();
    buttonPane.add(importName);
    buttonPane.add(deleteButton);
    buttonPane.add(addButton);
    buttonPane.add(okButton);

    Container contentPane = getContentPane();
    contentPane.add(listScrollPane, BorderLayout.CENTER);
    contentPane.add(buttonPane, BorderLayout.SOUTH);

    getRootPane().setDefaultButton(okButton);
    pack();
  }

  class AddListener implements ActionListener{       
    public void actionPerformed(ActionEvent e) {
      //User didn't type in a name...
      if (importName.getText().equals("")) {
        Toolkit.getDefaultToolkit().beep();
        return;
      }

      int index = list.getSelectedIndex();
      int size = listModel.getSize();
      
      //If no selection or if item in last position is selected,
      //add the new hire to end of list, and select new hire
      if (index == -1 || (index+1 == size)) {
        listModel.addElement(importName.getText());
        list.setSelectedIndex(size);

      //Otherwise insert the new hire after the current selection,
      //and select new hire
      } else {
        listModel.insertElementAt(importName.getText(), index+1);
        list.setSelectedIndex(index+1);
      }
    }
  };

  class OkListener implements ActionListener{
    Component c;
    OkListener(Component c){this.c = c;}

    public void actionPerformed(ActionEvent e) {
      c.setVisible(false);
    }
  };

  public void valueChanged(ListSelectionEvent e) {
    if (!e.getValueIsAdjusting()) {

      if (list.getSelectedIndex() != -1) {
        addButton.setEnabled(true);
        String name = list.getSelectedValue().toString();
        importName.setText(name);
      }
    }
  }

}

